#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################



from Products.Archetypes.public import Schema
from Products.ATContentTypes.types.schemata import ATFolderSchema
from Products.ATContentTypes.types.ATFolder import ATFolder
from Products.ATContentTypes.types.ATContentType import updateActions

from Products.Archetypes.public import registerType

from Products.CMFDocMgt.config import *

from Products.CMFDocMgt.Permissions import *


from Products.Archetypes.public import DateTimeField, StringField
from Products.Archetypes.public import CalendarWidget, StringWidget

from Acquisition import aq_inner, aq_base, aq_chain, aq_parent

from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from ComputedAttribute import ComputedAttribute
from Products.CMFPlone.PloneFolder import ReplaceableWrapper

from Products.CMFCore.utils import getToolByName
from OFS.ObjectManager import ObjectManager

from AccessControl import getSecurityManager, SpecialUsers
from Products.RevisionManager.util import escape_string, unescape_string

### for ftp
from StringIO import StringIO
from ZPublisher.HTTPRequest import HTTPRequest
from ZPublisher.HTTPResponse import HTTPResponse
from ZPublisher.mapply import mapply

import string
import os.path
import DateTime

#############################################################################
##                             Setting                                     ##
#############################################################################

schema = ATFolderSchema +  Schema((
    StringField('id',
                 required=1,
                ),
    StringField('title',
                required=1,
                ),
    StringField('contact',
                required=1,
                widget=StringWidget(label_msgid='label_contact',i18n_domain='CMFDocMgt',description=' ',),
                ),
    DateTimeField('deadline',
                widget=CalendarWidget(label_msgid='label_deadline',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('email',
                validator='validate_email',
                widget=StringWidget(label_msgid='label_email',i18n_domain='CMFDocMgt',description=' ',),
                ),
    ))

class DocMgtFolderBase(ATFolder):
    """
        DocMgtRoot is folderish object for DocMgt Folder
    """
    
    schema         =  schema
    content_icon   = 'folder_icon.gif'
    meta_type      = 'DocMgtFolderBase'
    archetype_name = 'DocMgtFolderBase'
    immediate_view = 'docmgtfolder_view'
    default_view   = 'docmgtfolder_view'
    
    
    
    suppl_views    = ()
    newTypeFor     = ()
    typeDescription= ''
    typeDescMsgId  = ''
    assocMimetypes = ()
    assocFileExt   = ()

    
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "Document Folder"
    
    global_allow = 0
    
    allowed_content_types=('DocMgtFolder','DocMgtFile',)
    
    filter_content_types = 1
    

    actions = updateActions(ATFolder,
        ( { 'id'            : 'folderContents'
            , 'name'          : 'Contents'
            , 'action'        : 'string: ${folder_url}/folder_contents'
            , 'condition'      : 'python: folder.displayContentsTab()'
            , 'permissions'   : (CMFCorePermissions.ListFolderContents, )
            , 'category'      : 'folder'
            , 'visible':0
            }
         ,  { 'id'            : 'view'
            , 'name'          : 'View'
            , 'action'        : 'string:docmgtfolder_view'
            , 'permissions'   : (CMFCorePermissions.View, )
            , 'visible':1
            }
          , { 'id'            : 'edit'
            , 'name'          : 'Edit'
            , 'action'        : 'string:base_edit'
            , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
            , 'category'      : 'object'
            }
          ,{ 'id'            : 'metadata'
            , 'name'          : 'Properties'
            , 'action'        : 'string:${object_url}/base_metadata'
            , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
            , 'category'       : 'object'
            , 'visible':0
            }
          , { 'id'            : 'folderlisting'
              , 'name'          : 'Folder Listing'
              , 'action'        : 'string:${folder_url}/docmgtfolder_view'
              , 'permissions'   :
                 (CMFCorePermissions.View,)
              , 'category'      : 'folder'
              , 'visible'       : 0
              }
          , { 'id'            : 'myfiles'
            , 'name'          : 'My Files'
            , 'action'        : 'string:${folder_url}/myfiles'
            , 'permissions'   : (CMFCorePermissions.View,)
            , 'visible':1
            , 'category'      : 'object'
            }
          , { 'id': 'metadata',
               'name': 'Properties',
               'action': 'string:${object_url}/base_metadata',
               'permissions': (CMFCorePermissions.ModifyPortalContent,),
               'visible':0
               },
        )
    )

    ################# override default pages/actions #####################
    def index_html(self):
        """ Acquire if not present. """
        _target = aq_parent(aq_inner(self)).aq_acquire('docmgtfolder_view')
        return ReplaceableWrapper(aq_base(_target).__of__(self))
        
    index_html = ComputedAttribute(index_html, 1)
    
    
    #security.declareProtected(Permissions.CMFDocMgtView, "folder_contents")
    def folder_contents(self):
        """ Acquire if not present. """
        REQUEST=self.REQUEST
        msg=REQUEST.get('portal_status_message', '').lower()
        
        if msg.find('renamed.') <>-1 or msg.find('copied.') or msg.find('cut.') <>-1 \
             or msg.find('pasted.') <>-1 or msg.find('changed.') <>-1:
            _target = aq_parent(aq_inner(self)).aq_acquire('docmgtfolder_view')
        else:
            _target = aq_parent(aq_inner(self)).aq_acquire('folder_contents')
        
        return ReplaceableWrapper(aq_base(_target).__of__(self))
        
    folder_contents = ComputedAttribute(folder_contents, 1)
    
    #def folder_rename(self):
    #    """ override the rename method """
    #    
    #    REQUEST=self.REQUEST
    #    self.manage_renameObjects(REQUEST['ids'], REQUEST['new_ids'], REQUEST)
    #    return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Item(s)+Renamed.')
    #    
    #folder_rename = ComputedAttribute(folder_rename, 1)
    
    #def folder_rename(self):
    #    """ override the rename method """
    #    
    #    REQUEST=self.REQUEST
    #    self.manage_renameObjects(REQUEST['ids'], REQUEST['new_ids'], REQUEST)
    #    return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Item(s)+Renamed.')
    #    
    #folder_rename = ComputedAttribute(folder_rename, 1)
    #
    #def folder_copy(self):
    #    """ override the copy method """
    #    REQUEST=self.REQUEST
    #    if REQUEST.has_key('ids'):
    #      self.manage_copyObjects(REQUEST['ids'], REQUEST, REQUEST.RESPONSE)
    #      return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Item(s)+Copied.')
    #    else:
    #      return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Please+select+one+or+more+items+to+copy+first.')
    #    
    #folder_copy = ComputedAttribute(folder_copy, 1)
    #
    #
    #def folder_cut(self):
    #    """ override the copy method """
    #    REQUEST=self.REQUEST
    #    if REQUEST.has_key('ids'):
    #      self.manage_cutObjects(REQUEST['ids'], REQUEST)
    #      return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Item(s)+Cut.')
    #    else:
    #      return REQUEST.RESPONSE.redirect(self.absolute_url() + '/?portal_status_message=Please+select+one+or+more+items+to+cut+first.')
    #    
    #folder_cut = ComputedAttribute(folder_cut, 1)
    #
    #
    #def folder_delete(self):
    #    """ override the delete method """
    #    REQUEST=self.REQUEST
    #    ret_url = self.absolute_url() + '/'
    #    
    #    if REQUEST.has_key( 'ids' ):
    #      self.manage_delObjects( REQUEST['ids'] )
    #      qs = '?portal_status_message=Deleted.'
    #      
    #    else:
    #      qs = '?portal_status_message=Please+select+one+or+more+items+first.'  
    #
    #
    #    return REQUEST.RESPONSE.redirect( ret_url + qs )
    #    
    #folder_delete = ComputedAttribute(folder_delete, 1)
    
    
    
    security.declareProtected(CMFCorePermissions.View, 'getIcon')
    def getIcon(self, relative_to_portal=0):
        return 'folder_icon.gif'
    
    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        ATFolder.manage_afterAdd(self,item, container)
        
        
    
    ###### Utils #########
    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    
    
    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative').replace('%20',' '),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )

    
    def PUT_factory( self, name, typ, body ):
        #"""
        #    Dispatcher for PUT requests to non-existent IDs.  Returns
        #    an object of the appropriate type (or None, if we don't
        #    know what to do).
        #"""
        #
        ##LOG('CMFDocMgt', INFO, 'FTP uploading file in %s, new file is %s ' % (self.getId(), name))
        #
        #registry = getToolByName( self, 'content_type_registry' )
        #if registry is None:
        #    return None
        #
        #typeObjectName = registry.findTypeName( name, typ, body )
        #if typeObjectName is None:
        #    return None
        ##bnHasDocAlready = 0
        #if typeObjectName in ['File', 'Image', 'Document']:
        #    typeObjectName = 'DocMgtFile'
        #    #bnHasObjAlready = hasattr(self, name)
        
        
        
        #registry = getToolByName( self, 'content_type_registry' )
        #portal_membership = getToolByName( self, 'portal_membership' )
        #contact = portal_membership.getAuthenticatedMember()    
        
        REQUEST = self.REQUEST
        self.invokeFactory( "DocMgtFile", name )
        
        
        file=getattr(self, name, None)
        
        #self.insertProperties(author)        
        #log = 'New file content uploaded via FTP'
        
        # "refill" the created file content
        #self[name].edit(file=body, content_type=typ, norev=1)
        values={}
        values['title']=name
        values['docstatus']='0'
        #values['file']=body
        file.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        #log = "FTP upload file"
        #REQUEST.set('log', log)
        
        #file.changeFile(body)
        #file.edit(file=body, norev=1)
        
        #obj = self[name]
        
        #LOG('CMFDocMgt', INFO, 'Created %s, id is %s ' % (typeObjectName, name))
        
        # XXX: this is butt-ugly.
        obj = aq_base( self._getOb( name ) )
        
        #if bnHasDocAlready:
        #    log = 'New file content uploaded via FTP'
        #    self._getOb( name ).updateRev(log)
        
        #self._delObject( name )
        
            
        #LOG('CMFDocMgt', INFO, 'File uploaded successfully after delete')
        #
        
        
        #self._setObject(name, obj)
        
        self[name].changeFile(body)
        
        ##request = self._create_fake_request()
        #request = self.REQUEST
        #request.other['BODY'] = body #request.other['BODYFILE'] = body
        ##request.set('put_factory', '1')
        #kw = { 'REQUEST': request, 'RESPONSE': request.RESPONSE }
        #mapply(obj.PUT, keyword=kw)
        #
        ##obj.PUT(body)
        
        return obj
        #return file
    
    def _create_fake_request(self):
        environ = os.environ.copy()
        environ['SERVER_NAME'] = 'localhost'
        environ['SERVER_PORT'] = ''
        response = HTTPResponse(stdout=StringIO())
        request = HTTPRequest(StringIO(''), environ, response)
        return request

    
    security.declarePublic( 'getFileSizeStr' )
    def getFileSizeStr(self, bytes):
    
        try:
            
            """
            Format a number of bytes as bytes, K, or MB.
            """
            megs=bytes / 1048576.0
            if megs > 1:
                return "%.2f MB" % megs
            k=bytes / 1024.0
            if k > 1:
                return "%d K" % k
            return "%d bytes" % bytes
        except:
            return None

    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    

    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()

    
class DocMgtRoot(DocMgtFolderBase):
    """
        DocMgtRoot is folderish object for DocMgt Folder
    """
    
    schema         =  DocMgtFolderBase.schema
    content_icon   = 'folder_icon.gif'
    meta_type      = 'DocMgtRoot'
    archetype_name = "Document Project"
    
    #immediate_view = 'docmgtroot_view'
    #default_view   = 'docmgtroot_view'
    
    
    
    #suppl_views    = ()
    #newTypeFor     = ()
    #typeDescription= ''
    #typeDescMsgId  = ''
    #assocMimetypes = ()
    #assocFileExt   = ()
    #
    #
    security = ClassSecurityInfo()
    
    #schema = schema
    
    
    global_allow = 1
    
    allowed_content_types=('DocMgtFolder','DocMgtFile',)
    
    filter_content_types = 1
    

    actions = updateActions(DocMgtFolderBase,
        ( { 'id'            : 'link_revisionmanager'
            , 'name'          : 'RM'
            , 'action'        : 'string:link_revisionmanager'
            , 'permissions'   : (CMFCorePermissions.ManageProperties,)
            , 'visible':1
            , 'category'      : 'object'
            },
        )
    )
          
    
        
    #############################################################################
    ##                             RevisionManager                             ##
    #############################################################################

        
        
    ## Script (Python) "checkOverDue"
    ##parameters=self
    ##title=Check the overdue date
    #        0 if not overdue
    #        1 if overdue
    security.declarePublic('checkOverDue')
    def checkOverDue(self, item):
        sdate = DateTime.DateTime().strftime('%Y/%m/%d')
        if not hasattr(item, 'getDeadline'): return 0
        if item.getDeadline():
            return sdate > item.getDeadline().strftime('%Y/%m/%d')
            #return test(sdate > str(item.deadline),1,0)
        else:
            return 0
        
        
    
    security.declarePrivate('deserialize')
    def deserialize(self, serials):
        assert type(serials) is type('')
        properties = []
        lines = serials.split('\n')
        for line in lines:
            if line.startswith('#'):
                continue
            try:
                key, value = line.split('=')
            except ValueError:
                continue
            id, typ = key.split(':')
            id.strip()
            typ.strip()
            value = unescape_string(value)
            try:
                if type_converters.has_key(typ):
                    value = type_converters[typ](value)
                properties.append({
                    'id':    id,
                    'type':  typ,
                    'value': value
                    })
            except:
                continue
        return tuple(properties)


    security.declareProtected(CMFCorePermissions.ManageProperties, "soqrm_mapFSObjects")
    def soqrm_mapFSObjects(self, REQUEST, RESPONSE, items=[]):
        """
        Map file system files to objects.
        """
        failed = []
        for item in items:
            if item.get('add', 0):
                path = item['path']
                rt = self.soqaddFSFileObject(path, item['meta_type'])
                if rt:
                    failed.append(path)
        if failed:
            message = "Object creation failed for: %s" % ' '.join(failed)
            portal_status_message = message
        else:
            portal_status_message = 'Config+Action+Finished+Successfully'
        return REQUEST.RESPONSE.redirect(self.absolute_url().replace('%20',' ') + '/view?portal_status_message=' + portal_status_message)


    security.declareProtected(CMFCorePermissions.ManageProperties, 'soqaddFSFileObject')
    def soqaddFSFileObject(self, path, meta_type):
        segments = path.split("/")
        rm = self.RevisionManager
        contact = self.portal_membership.getAuthenticatedMember()
        # first make sure that the directory part of the path exists
        # if it doesn't, create as many folders as necessary
        folder = aq_inner(self) #aq_parent(aq_inner(self))
        for id in segments[:-1]:
            subfolder = getattr(folder, id, None)
            if subfolder is None:
                folder.invokeFactory(id=id, type_name='DocMgtFolder', title=id)
                subfolder = getattr(folder, id)
            folder = subfolder

        # now add the object
        # first the the appropriate factory
        id = segments[-1]
        abs_filename = rm.getAbsoluteFilePath(path)
        # read the file contents
        data = open(abs_filename, "rb").read()

        self.REQUEST.set('MappingRM', 1)
        if not rm._settings['save_properties']:
            try:
                #folder.invokeFactory(id=id, type_name='DocMgtFile')
                folder.invokeFactory( 'DocMgtFile', id)
                obj=getattr(folder, id, None)
                #obj.insertProperties(author)
                title = id
                obj.edit(title=title,
                         description='It is ' + title,
                         file=data,
                         contact=contact,
                         email='')
                #obj.edit(title=title,
                #         description='It is ' + title,
                #         file=data,
                #         author=author,
                #         email='')
            except:
                return 1
            
            #folder._setObject(id, obj)
            return 0

        basename = os.path.basename(abs_filename)
        dirname = os.path.dirname(abs_filename)
        prop_path = os.path.join(dirname, "." + basename + '.properties')

        properties = ()
        title = id
        props = {}
        # it could be that there is no properties file, so we
        # better check
        if os.path.isfile(prop_path):
            # read the properties file and deserialize the data
            fp = open(prop_path, "rb")
            serial = fp.read()
            fp.close()
            properties = self.deserialize(serial)

            for propdict in properties:
                if propdict['id'] == 'title':
                    title = propdict['value']
                else:
                    props[propdict['id']] = propdict['value']

        # create the object
        try:
            folder.invokeFactory( 'DocMgtFile', id)
            obj=getattr(folder, id, None)
            
            obj.edit(title=title, 
                     file=data,
                     **props)

        except:
            return 1

        # write properties if available and possible
        if properties:
            adapter = propertyAdapterRegistry.getAdapter(obj)
            if adapter is not None:
                obj_status = rm.getStatus(path)
                obj_status['have_props'] = 1
                if properties != adapter.getProperties(obj):
                    try:
                    
                        adapter.setProperties(obj, properties)
                    except:
                        return 1
        #obj.insertProperties(author)
        #folder._setObject(id, obj)
        return 0


    #############################################################################
    
registerType(DocMgtRoot)



class DocMgtFolder(DocMgtFolderBase):
    """
        DocMgtFolder is folderish object for Files
    """
    
    schema         =  DocMgtFolderBase.schema

    content_icon   = 'folder_icon.gif'
    meta_type      = 'DocMgtFolder'
    archetype_name = 'DocMgtFolder'
    
    
    suppl_views    = ()
    newTypeFor     = ()
    typeDescription= ''
    typeDescMsgId  = ''
    assocMimetypes = ()
    assocFileExt   = ()

    
    security = ClassSecurityInfo()
    
    archetype_name = "Folder"
    
    global_allow = 0
    
    
    
        

registerType(DocMgtFolder)
